#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1024;
char a[MAXN][MAXN];
int levels[MAXN][MAXN];
int maxPacienti[MAXN][MAXN];
bool used[MAXN][MAXN];
pair<int, int> dirs[4] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m; cin >> n >> m;

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }
    pair<int, int> start, fin;

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            if(a[i][j] == 'S') start = {i, j};
            else if(a[i][j] == 'T') fin = {i, j};
        }
    }

    queue< pair<int, int> > q;
    q.push(start);
    used[start.first][start.second] = true;

    while(!q.empty()) {
        pair<int, int> curr = q.front(); q.pop();

        for(int i = 0; i < 4; i++) {
            int x2 = curr.first + dirs[i].first;
            int y2 = curr.second + dirs[i].second;

            if(x2 < 1 || x2 > n || y2 < 1 || y2 > m || used[x2][y2] || a[x2][y2] == 'x') continue;

            used[x2][y2] = true;
            q.push({x2, y2});
            levels[x2][y2] = 1 + levels[curr.first][curr.second];
        }

        for(int i = 0; i < 4; i++) {
            int x2 = curr.first + dirs[i].first;
            int y2 = curr.second + dirs[i].second;

             if(x2 < 1 || x2 > n || y2 < 1 || y2 > m) continue;

             maxPacienti[x2][y2] = max(maxPacienti[x2][y2], maxPacienti[curr.first][curr.second] + (a[x2][y2] == '+'));
        }
    }

    cout << levels[fin.first][fin.second] << " " << maxPacienti[fin.first][fin.second] << endl;

    return 0;
}
